/* 

        Copyright (C) 1995-2000
        Free Software Foundation, Inc.

   This file is part of GNU cfengine - written and maintained 
   by Mark Burgess, Dept of Computing and Engineering, Oslo College,
   Dept. of Theoretical physics, University of Oslo
 
   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version. 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

*/

/*****************************************************************************/
/*                                                                           */
/* File: methods.c                                                           */
/*                                                                           */
/*****************************************************************************/

#include "cf.defs.h"
#include "cf.extern.h"

/* Create package with host:ptrr->name as filename
   Includes TTL - should be in filename, since file encrypted
       Filename of module, relative to modulesdir
       Prototypes for checking integrity
       Checksums of attachments
       Encrypted

control:

  MethodPrototype = ()
       
alerts:

  MethodReturn($a,$b...)
  MethodClasses(class2,class5) # return if defined
  
*/

/*****************************************************************************/

void DispatchNewMethod(ptr)

struct Method *ptr;

{ struct Item *ip;

for (ip = ptr->servers; ip != NULL; ip=ip->next)
   {
   if (strcmp(ip->name,"localhost") != 0)
      {
      printf("Dispatch method %s:%s to %s/rpc_out\n",ip->name,ptr->name,VLOCKDIR);
      }
   else
      {
      printf("Dispatch method localhost:%s to %s/rpc_in\n",ptr->name,VLOCKDIR);
      }
   } 
}

/*****************************************************************************/

struct Method *GetPendingMethods()

{ char filename[maxvarsize],path[bufsize];
  DIR *dirh;
  struct dirent *dirp;
  struct Method **list = NULL;

Debug("Look for methods in %s/rpc_in\n",VLOCKDIR);
 
snprintf(filename,maxvarsize-1,"%s/rpc_in",VLOCKDIR);
 
if ((dirh = opendir(filename)) == NULL)
   {
   snprintf(OUTPUT,bufsize*2,"Can't open directory %s\n",path);
   CfLog(cfverbose,OUTPUT,"opendir");
   return NULL;
   }

for (dirp = readdir(dirh); dirp != NULL; dirp = readdir(dirh))
   {
   if (!SensibleFile(dirp->d_name,path,NULL))
      {
      continue;
      }

   snprintf(path,bufsize-1,"%s/%s",VLOCKDIR,dirp->d_name);

   printf("Load Method: %s\n",path);

/*   if (relevant to me)
      {
      AppendMethod(list,path,"");
      }*/
   }

closedir(dirh);

if (list == NULL)
   {
   return NULL;
   }
 
return *list;
}

/*****************************************************************************/

void EvaluatePendingMethod(ptr)

struct Method *ptr;

{
 printf("Look for methods in %s/rpc_in\n",WORKDIR);
}

/*****************************************************************************/

void DeleteMethodList(list)

struct Method *list;

{
}
